// =========================================================================
// $Source: /home/cvs/Taktuk2/NetworkCore/src/acom_fmtcompile.cpp,v $
// (c) INRIA, projet APACHE, 2001
// Author: T. Gautier
//
//
//
// =========================================================================
#include <inuk/acom_format.h>
#include <inuk/acom_fmtstream.h>

/* 
*/
namespace ACOM_NET_NAMESPACE {

// --------------------------------------------------------------------
/* Compile a format using fact that architecture are homogenous
*/
void Format::compile() const
{
  if (_iscompiled) return;
  if (!_couldbecompiled) return;

/*  if (get_id() <= FormatDef::LDouble.get_id())
  {
    _iscompiled = true;
    _iscontiguous = true;
    return;
  }
*/  
  /* to avoid infinite recursion */
  _iscompiled   = true;
  _iscontiguous = true;

// TG
  return;
  /* base for offset computation */
  void* data = create();
  
  /* compile the format: output part */
  StreamFormat os(data, &_out_iov_i, &_out_iov_d );
  write( os, data, 1 );
  
  if (_out_iov_i.size() <= 1) {
    _couldbecompiled = false;
    goto phase2;
  }


  /* Compact immediate data */
  {
    long pad = 8; /* tolerance for pading */
    int  pos =0;
    Format::OffSetDataOut curr( _out_iov_i[0] );
    if (!curr.fmt->_iscompiled && curr.fmt->_couldbecompiled)
      curr.fmt->compile();
  
    for (size_t i =1; i<_out_iov_i.size(); ++i)
    {
      if (!_out_iov_i[i].fmt->_iscompiled && _out_iov_i[i].fmt->_couldbecompiled)
        _out_iov_i[i].fmt->compile();
        
      long offset_endprev = _out_iov_i[i-1].offset + _out_iov_i[i-1].count * _out_iov_i[i-1].fmt->get_size();
      if ((_out_iov_i[i].offset - offset_endprev <= pad ) && _out_iov_i[i].fmt->_iscontiguous)
      {
        /* accumulate fmt->_out_iov_i[i] with previous iovector :
            - count -> in byte : end of fmt->_out_iov_i[i] field - begin offset
            - fmt is now in byte
        */
        curr.fmt = &FormatDef::Byte;
        curr.count = _out_iov_i[i].offset + _out_iov_i[i].count * _out_iov_i[i].fmt->get_size()-curr.offset;
      } else {
        _out_iov_i[pos] = curr;
        curr = _out_iov_i[i];
        ++pos;
        if ( !_out_iov_i[i].fmt->_iscontiguous )
          _iscontiguous = false;
      }
    }
    _out_iov_i.resize( pos );
  }
    
phase2:
  if (_out_iov_d.size() >0)
    _iscontiguous = false;

  for (size_t i =0; i<_out_iov_d.size(); ++i)
  {
    if (!_out_iov_d[i].fmt->_iscompiled && _out_iov_d[i].fmt->_couldbecompiled)
      _out_iov_d[i].fmt->compile();
  }
  destroy( data );
}


// --------------------------------------------------------------------
void Format::compile_all()
{
  for (int i = 1; i < Format::_counter; ++i)
    Format::get_format(i)->compile();
}

} // namespace
