/*
 * The contents of this file are subject to the Dyade Public License,
 * as defined by the file DYADE_PUBLIC_LICENSE.TXT
 *
 * You may not use this file except in compliance with the License. You may
 * obtain a copy of the License on the Dyade web site (www.dyade.fr).
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific terms governing rights and limitations under the License.
 *
 * 
 * 
 *
 * The Initial Developer of the Original Code is Dyade. The Original Code and
 * portions created by Dyade are Copyright Bull and Copyright INRIA.
 * All Rights Reserved.
 */
/* Copyright (c) 1997 by Groupe Bull. Read the COPYRIGHT file. */
/* $Id: */
/* Author: Cyrille.Martin@imag.fr */

/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */

#include "barrier.h"
#include "debuglog.h"
#include <inuk/acom>
#include <inuk/taktuk/taktuknetwork.h>
#include <pthread.h>




int Barrier::sync()
{

  int res=1;
	if(_count_node<=1)
		return res;
  dbg.log("barrier","!!!!!!!!!!!!!!!!!!!!!!!!!!!!!BEGIN SYNC!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
  if(_rank==0)
	{
		waitfor(_count_node-1);
		try
		{
			Taktuk::Network::OutChannel* com;
			com=_net->get_default_route(Taktuk::Network::ALL);
			acom::ActiveMessage<Barrier>am (_net, this, 0);
			am->pack(&_id,sizeof(_id));
			if(_id==0xFFFF)
  				_id=0;
  			_id++;
			am.post(com);
			dbg.log("barrier", "msg sent\n");
		}
		catch(...)
//		catch(acom::ComFailure &e)
		{
			res= -1;
		}
	}
  else
 	{
      
	  try
	  {
			Taktuk::Network::OutChannel* com;
			com=_net->get_default_route(0);
			acom::ActiveMessage<Barrier>am (_net, this, 0);
			am->pack(&_id,sizeof(_id));
			am.post(com);
			dbg.log("barrier", "msg sent\n");
	  }
	  catch(...)
	  {
			res= -1;
	  }
	  waitfor(1);
          if(_id==0xFFFF)
             	_id=0;
          _id++;
	  dbg.log("barrier", "Apres waitack \n");
	}
	
  if(res>0)
    dbg.log("barrier","!!!!!!!!!!!!!!!!!!!!!!!!END SYNC [OK]!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
  else
    dbg.log("barrier","!!!!!!!!!!!!!!!!!!!!!!!!END SYNC [FAILED]!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
  return res;
}

void Barrier::waitfor(int c_nodes)
{
//  int res=0;
//  _countdown += c_nodes;
//  _countdown.init(c_nodes + );
//  _countdown.wait();
//
  count_mutex.lock();
//  pthread_mutex_lock(&count_mutex);
  _count = _count + c_nodes;
  
  
  while(_count > 0)
  {
	dbg.log("barrier","___________________Wait for %d nodes__________________________\n",_count);
	count_cond.wait(count_mutex);
//    pthread_cond_wait(&count_cond, &count_mutex);
  }
  _count=0;
  count_mutex.unlock();
//  pthread_mutex_unlock(&count_mutex);

  //return res;
}




void Barrier::ack()
{
//  --_countdown;
    count_mutex.lock();
//  pthread_mutex_lock(&count_mutex);
  _count--;
  dbg.log("barrier","________________________SYNC COUNT -- = %d _________________\n",_count);
   count_cond.signalnothrow();
   count_mutex.unlock();
//  pthread_cond_signal(&count_cond);
//  pthread_mutex_unlock(&count_mutex);
}

void Barrier::call(acom::ComFailure::Code error_no,
		            acom::Network::Receipt* receipt,
					acom::Network::Header* header,
					acom::IOVectEntry* vector,
					acom::IOVectSize count,
          void* ctxt
  )throw(acom::ComFailure)
{
  //dbg.log("barrier","???????????????????????????AM service  synchro????????????????????????????????\n");
  id_t msgid;
  receipt->unpack(&msgid,sizeof(id_t));
  //dbg.log("barrier","???????????????????????AM service synchro barrier ID %d msg ID %d ???????????????????\n",_id,msgid);
  if(_id==msgid)
    ack();
  else
    dbg.log("barrier", "received msgid %d, expected: %d", _id, msgid);
}

