/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */

#ifndef __ENVRSH_H
#define __ENVRSH_H


#include <vector>
#include <string>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/tcp.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include "connector.h"
#include "taktukexec.h"
#include "connector_envrsh.h"

class envrsh:public connector
{
  void run()
	{
		int nb_hosts=remote_hosts.size();

		std::vector<std::string> cmd_ssh;

		int fd[nb_hosts];

		//cout<<"\trsh_async-->begin "<<endl;
		char* env (getenv("TAKTUK_RSH"));
		if(env==NULL)
			{
				for(int i=0; i<nb_hosts; i++)
		{
			reject->push_back(remote_hosts[i]);
			remote_hosts[i]->fd=-1;
		}
				return;
			}
/*		
		char* redirector = getenv("TAKTUK_REDIR");
		std::string redir_str;
		if(redirector==NULL)
			redir_str="";
		else
			redir_str=redirector;
*/
		std::string env_str(env);

		for(int i=0; i<nb_hosts; i++)
			{
				if(remote_hosts[i]->gateaccess.empty())
					cmd_ssh.push_back(env_str + " " + remote_hosts[i]->name + " " + remote_hosts[i]->cmd );
				else
					cmd_ssh.push_back(remote_hosts[i]->gateaccess + " " + env_str + " " + remote_hosts[i]->name + " " + remote_hosts[i]->cmd );

				//dbg.log("envrsh", "CMD : %s \n", cmd_ssh[i].c_str());
				//cout<<"\trsh_async-->hosts: "<<remote_hosts[i]<<endl;
				//cout<<"\trsh_async-->cmd: "<<cmd_str[i]<<endl;
			}

		for(int i=0; i<nb_hosts; i++){
			fd[i]=taktukexec((char*)cmd_ssh[i].c_str());
			//dbg.log("", "fd[%d]=%d \n", i, fd[i]);
		}

		for(int i=0; i<nb_hosts; i++)
			{
				// cout << "fd = " << fd[i] << endl;
		if (fd[i] == -1)
		{
			//dbg.log("", " connection to remote host %s refused \n", (char*)remote_hosts[i]->name.c_str());
			reject->push_back(remote_hosts[i]);
		}
				remote_hosts[i]->fd=fd[i];
			}
	}
};

#endif //__ENVRSH_H
