/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */
 
#ifndef __RSH_ASYNC_THREAD_H
#define __RSH_ASYNC_THREAD_H


#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include "connector.h"
#include <pthread.h>
#include <signal.h>
#include <netdb.h>
#include <sys/wait.h>

#include <vector>
#include <string>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/tcp.h>
#include <netinet/in.h>
#include <stdio.h>
#include <iostream>
#include <pthread.h>
#include "rcmd_async.h"

class rsh_thread;
void thread_routine(rsh_thread* rsh_async);

class rsh_thread:public connector
{
	private :
		
	int rport;
	int tcpopt_nodelay_on;
	char** r_hosts;
	char** cmd_str;
	pthread_mutex_t mutex;
	int addr_ind;
	int hosts_no_connect;
	pthread_t* pid;	
	
	friend void thread_routine(rsh_thread* rsh_async);
	
	int getAddrHosts(){
		int ret;
		pthread_mutex_lock(&mutex);
		if (hosts_no_connect == 0) {
			ret = -1;
		}
		else {

			ret = addr_ind;

			hosts_no_connect -= 1; 
			addr_ind += 1;
		}
		pthread_mutex_unlock(&mutex);  
		return ret;
	}
	
	public :

	rsh_thread() {
		addr_ind = 0;
		rport = 514;
		tcpopt_nodelay_on = 1;  
		pthread_mutex_init(&mutex, NULL);
	}
	~rsh_thread(){
		pthread_mutex_destroy(&mutex);
	}
	
	void run()	 
	{
		int nb_hosts = remote_hosts.size();
		r_hosts = (char**)(malloc(nb_hosts*sizeof(char*)));
		cmd_str = (char**)(malloc(nb_hosts*sizeof(char*)));
		pid = (pthread_t*)malloc(nb_hosts*sizeof(pthread_t));
		hosts_no_connect = nb_hosts;
		
		
		for(int i=0; i<nb_hosts; i++)
			{      
				r_hosts[i] = (char*)(remote_hosts[i]->name.c_str());
				cmd_str[i] = (char*)(remote_hosts[i]->cmd.c_str());
			}


		for(int i=0; i<nb_hosts; i++) 
			pthread_create(&(pid[i]), NULL, (void *(*)(void*))thread_routine, this);


		for(int i = nb_hosts - 1; i >= 0; i--)
		{
		 pthread_join(pid[i], NULL);
		}
		addr_ind=0;
		free(r_hosts);
		free(cmd_str);
		free(pid);
	}
};

void thread_routine(rsh_thread *rsh_async) {

	int addr_ind;
	addr_ind  = rsh_async->getAddrHosts();
	if(addr_ind==-1)
		return;
	//char* cmd_str = (rsh_async->cmd_str)[addr_ind]; 
	rcmd_async(&(rsh_async->r_hosts[addr_ind]), 1, &(rsh_async->remote_hosts[addr_ind]->fd), rsh_async->rport, (char*)(rsh_async->local_user.c_str()), (char*)((rsh_async->remote_hosts[addr_ind]->login).c_str()), &((rsh_async->cmd_str)[addr_ind]));

	if (rsh_async->remote_hosts[addr_ind]->fd != -1){
		if(setsockopt(rsh_async->remote_hosts[addr_ind]->fd,IPPROTO_TCP,TCP_NODELAY,&(rsh_async->tcpopt_nodelay_on),sizeof(rsh_async->tcpopt_nodelay_on))==-1)
						perror("WARNING:");
		
	}
	else
	{
		(rsh_async->reject)->push_back(rsh_async->remote_hosts[addr_ind]);
		dbg.log("","connector rsht after rcmdasync FAILED\n");	
	}
}
#endif //__RSH_THREAD_H
