/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */

#ifndef __SSH_H
#define __SSH_H


#include <vector>
#include <string>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/tcp.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include "connector.h"
#include "taktukexec.h"
#include <sys/types.h>
#include <signal.h>


class ssh:public connector
{
	public:
		ssh()
		{
			size=0;
			pid=0;
		}
  void run()
	{
		int nb_hosts=remote_hosts.size();
		size=nb_hosts;

		std::vector<std::string> cmd_ssh;

		int fd[nb_hosts];

		//cout<<"\trsh_async-->begin "<<endl;
		/*
		char* redirector = getenv("TAKTUK_REDIR");
		std::string redir_str;
		if(redirector==NULL)
			redir_str="";
		else
			redir_str=redirector;
		*/

		for(int i=0; i<nb_hosts; i++)
			{
				if(remote_hosts[i]->gateaccess.empty())
					cmd_ssh.push_back("ssh -q -o StrictHostKeyChecking=no " +  remote_hosts[i]->login + "@" + remote_hosts[i]->name + " " + remote_hosts[i]->cmd );
				else
					cmd_ssh.push_back(remote_hosts[i]->gateaccess + " ssh -q -o StrictHostKeyChecking=no " +  remote_hosts[i]->login + "@" + remote_hosts[i]->name + " " + remote_hosts[i]->cmd );

				//dbg.log("ssh", "CMD : %s \n", cmd_ssh[i].c_str());
				//cout<<"\trsh_async-->hosts: "<<remote_hosts[i]<<endl;
				//cout<<"\trsh_async-->cmd: "<<cmd_str[i]<<endl;
			}

		for(int i=0; i<nb_hosts; i++){
			fd[i]=taktukexec((char*)cmd_ssh[i].c_str(),&pid);
			//dbg.log("", "fd[%d]=%d \n", i, fd[i]);
		}

		for(int i=0; i<nb_hosts; i++)
			{
				// cout << "fd = " << fd[i] << endl;
		if (fd[i] == -1)
		{
			//dbg.log("", " connection to remote host %s refused \n", (char*)remote_hosts[i]->name.c_str());
			reject->push_back(remote_hosts[i]);
		}
				remote_hosts[i]->fd=fd[i];
			}
	}

	void cancel()
	{
		if(pid!=0&&size==1)
			kill(pid,SIGKILL);
	}
	private:
		int pid;
		int size;
};

#endif //__SSH_FORK_H
