/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */

#include "debuglog.h"
#include <unistd.h>
#include <string>
#include <stdio.h>
#include <fcntl.h>
#include <signal.h>

//#ifndef DEBUGLIST
//#define DEBUGLIST "\" redirIO IOredir  dojob getinfo setinfo steal scheduler info init taktuk_init taktuk_terminate spawner barrier topology_analyser taktukexec WARNING: PANIC: connector debuglog topo timeout prof ERROR \""
//#endif
// NOT TO BE COMMITED
#ifdef DEBUGLIST
#undef DEBUGLIST
#endif
#define DEBUGLIST "\" ERROR SOCKET dojob getinfo setinfo steal scheduler info init router process post taktuk_init taktuk_terminate redirIO spawner remote_call barrier output_service input_service topology_analyser localIOprocess am_call readall sendall taktukexec sendiov outchannel read_header WARNING: PANIC: envrsh connector IOredir input output debuglog topo readiov \""

debuglog dbg;

#ifdef DEBUG
void segfaulthandler(int i)
{
	dbg.log("","SEGFAULT TRAPPED\n");
	exit(0);
}
#endif

void debuglog::open()
{
  char hostname[128];
	gethostname(hostname,1238);
	filename= filename +"_"+ hostname;
  sprintf(pid,"%d\0",getpid());
  filename= filename + "_" + pid;
  fd=fopen(filename.c_str(),"a");
  if(fd==NULL)
    {
      filename=filename + ".bis";
      fd=fopen(filename.c_str(),"a");
    }
	if(fd==NULL)
	{
		std::cerr<<"Can't create debug trace file :"<<filename<<"	Abort"<<std::endl;
	}
  fcntl(fileno(fd), F_SETFD, FD_CLOEXEC);

}

void debuglog::setrank(int r)
{
  rank = r;
  log("debuglog"," RANK set to %d \n",rank);
#ifdef DEBUG
	if(rank!=0)
		signal(SIGSEGV, segfaulthandler);
#endif
}

debuglog::debuglog()
{
  log_mutex.initnothrow();
  list=DEBUGLIST;  
  filename=*new std::string(LOGFILE) + *new std::string(pid);
  fd=NULL;
  rank=0;
  //open();
}

debuglog::debuglog(std::string& logfile)
{
  log_mutex.initnothrow();
  list=DEBUGLIST;  
  filename=logfile;
  fd=NULL;
  rank=0;
  //  open();
}

debuglog::debuglog(char* logfile)
{
  log_mutex.initnothrow();
  list=DEBUGLIST;  
  filename= *new std::string(logfile);
  fd=NULL;
  rank=0;
  //  open();
}

debuglog::debuglog(std::string& logfile, std::string& debuglist)
{
  log_mutex.initnothrow();
  list=debuglist; 
  filename=logfile;
  fd=NULL;
  rank=0;
  //  open();
}

debuglog::debuglog(char* logfile, char* debuglist)
{
  log_mutex.initnothrow();
  filename= *new std::string(logfile);
  list=debuglist;
  fd=NULL;
  rank=0; 
  //open();
}

debuglog::~debuglog()
{
  try
    {
      log_mutex.destroy();
    }
  catch(...)
    {
      ;
    }
  if(fd!=NULL)
    fclose(fd);
}

/*
void debuglog::log(char* name,char* format...)
{
#ifndef DEBUG
#ifndef PROFILE
	  return;
#endif
#endif
  if(strcmp(name,"")==0 || list.find(name,0)!=std::string::npos)
    {
      
      if(fd == NULL)
	open();
      if(fd!=NULL)
	{
	  log_mutex.locknothrow();
	  va_list ap;
	  if (strcmp(name,"")!=0)
	    fprintf(fd,"%s <nid:%d>:",name,rank);
	  va_start(ap,format);
	  
	  if(fd!=NULL)
	    vfprintf(fd,format,ap);
      
	  va_end(ap);
	  fflush(fd);
	  log_mutex.unlocknothrow();
	}
    }
}
*/
void debuglog::Xmem(void* begin, int size)
{
  log("mem","men 0xadr \t val0x \t val int \t val char\n"); 
  for(int i=0; i<size ;i++)
    {
      log("mem","mem 0x%x : %x\t%d\t%c\n",(char*)begin+i,(char)(*((char*)begin+i)),(char)(*((char*)begin+i)),(char)(*((char*)begin+i)));
    }
}
