#include <inuk/taktuk/mput_receiver.h>
#include <inuk/taktuk/mput_wrappers.h>
#include <inuk/taktuk/mput_buffers.h>

volatile int receiver_finished;

ssize_t Read_fix(int fd, void *buf, size_t count)
{
   ssize_t result;
   if( (result = read(fd, buf, count)) < 0 )
   {
      if( receiver_finished )
         return 0;
      else
         error_report("read_error",errno);
   }
   return result;
}

void * receiver(void * socket)
{
   int current_buffer = 0;
   int n;
   int last_buffer = NBBUFF - 1;
   
   receiver_finished=0;
   
   while(!receiver_finished)
   {


      Pthread_mutex_lock(&(buffers[current_buffer].buffer_full_mutex));
      while(buffers[current_buffer].buffer_full != 0)
         Pthread_cond_wait(&(buffers[current_buffer].buffer_full_cond),&(buffers[current_buffer].buffer_full_mutex));
      Pthread_mutex_unlock(&(buffers[current_buffer].buffer_full_mutex));

      Pthread_mutex_lock(&(buffers[current_buffer].prod_mutex));
      buffers[current_buffer].prod = 1;
      Pthread_mutex_unlock(&(buffers[current_buffer].prod_mutex));
      
      Pthread_mutex_lock(&(buffers[last_buffer].prod_mutex));
      buffers[last_buffer].prod = 0;
      Pthread_cond_broadcast(&(buffers[last_buffer].prod_cond));
      Pthread_mutex_unlock(&(buffers[last_buffer].prod_mutex));
     
      n=0;
      /*fix for the broken pipe bug caused by a read error due to invalide fd*/
      while( (n += Read_fix(*((int *)socket),&(buffers[current_buffer].buff[n]),MAXBUFF-n)) < MAXBUFF)
      {
         if( receiver_finished )
	    return NULL;
      }
      
      Pthread_mutex_lock(&(buffers[current_buffer].buffer_full_mutex));
      buffers[current_buffer].buffer_full = nb_consumers;
      Pthread_mutex_unlock(&(buffers[current_buffer].buffer_full_mutex));

      last_buffer = current_buffer;
      current_buffer++;
      if(current_buffer == NBBUFF)
         current_buffer = 0;
   }
   return NULL;
}
