#include <inuk/taktuk/scheduler.h>
#include <scheduler_services.h>
#include <inuk/acom>
#include <vector>
#include <inuk/taktuk/taktuknetwork.h>
#include <inuk/taktuk/topology.h>



/**********************************************************/
void steal::initialize(scheduler* s){
		_jschd=s;
	}
void steal::call(
		acom::ComFailure::Code error_no,
		acom::Network::Receipt* receipt,
		acom::Network::Header* header,
		acom::IOVectEntry* vector,
		acom::IOVectSize count,
    void* ctxt
		) throw(acom::ComFailure)
{
	Taktuk::Network::TaktukReceipt* recpt = (Taktuk::Network::TaktukReceipt*)receipt;
	acom::Network::LocalNodeNo LocalID = recpt->get_reply_channelID();

	dbg.log("steal","_______STEAL CALLED BY local child________ %d\n",LocalID);
	_jschd->SubscribeToSteal(LocalID);
}

/**********************************************************/
/**********************************************************/
void getinfo::initialize(scheduler* s)
{
	_jschd=s;
}
void getinfo::call(
		acom::ComFailure::Code error_no,
		acom::Network::Receipt* receipt,
		acom::Network::Header* header,
		acom::IOVectEntry* vector,
		acom::IOVectSize count,
    void* ctxt
		) throw(acom::ComFailure)
{
	acom::Network::LocalNodeNo size;
	if(error_no != acom::ComFailure::OK)
		return;
	Taktuk::Network::TaktukReceipt* recpt = (Taktuk::Network::TaktukReceipt*)receipt;
	acom::Network::LocalNodeNo LocalID = recpt->get_reply_channelID();
	dbg.log("getinfo","_______GET INFO CALLED BY local child________ %d\n",LocalID);
	_jschd->childs_map_mut.lock();
	recpt->unpack(&size,sizeof(acom::Network::LocalNodeNo));
	dbg.log("getinfo","_______GET INFO local child %d size %d _______\n",LocalID,size);
	_jschd->childs_map[_jschd->info->rank==0?LocalID:LocalID-1]->size=size;
	_jschd->childs_map_mut.unlock();
	// update info request count!!!!!
	_jschd->nbInfoReq_mut.lock();
	_jschd->nbInfoReq--;
	_jschd->nbInfoReq_cond.signal();
	_jschd->nbInfoReq_mut.unlock();
}

/**********************************************************/
/**********************************************************/
void setinfo::initialize(scheduler* s)
{
	_jschd=s;
}
void setinfo::call(
		acom::ComFailure::Code error_no,
		acom::Network::Receipt* receipt,
		acom::Network::Header* header,
		acom::IOVectEntry* vector,
		acom::IOVectSize count,
    void* ctxt
		) throw(acom::ComFailure)
{
	acom::Network::LocalNodeNo rank=0;
	acom::Network::LocalNodeNo uprank=0;
	acom::Network::LocalNodeNo nodescount=0;
	if(error_no != acom::ComFailure::OK)
		return;
	//set info in job sckeduler

	receipt->unpack(&rank,sizeof(acom::Network::LocalNodeNo));
	receipt->unpack(&uprank,sizeof(acom::Network::LocalNodeNo));
	receipt->unpack(&nodescount,sizeof(acom::Network::LocalNodeNo));

	dbg.log("setinfo","============= SETINFO CALLED =============\n");
	_jschd->set_info(rank,uprank,nodescount);

}

/**********************************************************/
/**********************************************************/
void dojob::initialize(scheduler* s)
{
	_jschd=s;
}
void dojob::call(
		acom::ComFailure::Code error_no,
		acom::Network::Receipt* receipt,
		acom::Network::Header* header,
		acom::IOVectEntry* vector,
		acom::IOVectSize count,
    void* ctxt
		) throw(acom::ComFailure)
{
	if(error_no != acom::ComFailure::OK)
	{
		dbg.log("ERROR","============= DOJOB RECEIVED WITH ERROR =============\n");
		return;
	}
	//record new job in the sckeduler

	dbg.log("dojob","============= DOJOB CALLED =============\n");
	dbg.log("dojob","============= DOJOB IOvectsize = %d header iovsz_d = %d\n",count,header->iovsz_d);
	std::vector<topology::host*> list;
	topology::host* hinter;
	for(int i=0;i<count;i+=11)
	{
		dbg.log("dojob","============= DOJOB ADD 1 JOB =============\n");
		//list.push_back((topology::host*)vector[i].data);
		hinter=new topology::host();
		if(vector[i+0].len>0)
			hinter->set_name((char*)vector[i+0].data);
		if(vector[i+1].len>0)
			hinter->set_connector((char*)vector[i+1].data);
		if(vector[i+2].len>0)
			hinter->set_taktukargs((char*)vector[i+2].data);
		if(vector[i+3].len>0)
			hinter->set_userargs((char*)vector[i+3].data);
		if(vector[i+4].len>0)
			hinter->set_login((char*)vector[i+4].data);
		if(vector[i+5].len>0)
			hinter->set_passwd((char*)vector[i+5].data);
		if(vector[i+6].len>0)
			hinter->set_cmd((char*)vector[i+6].data);
		if(vector[i+7].len>0)
			hinter->set_size(*(int *)(vector[i+7].data));
		if(vector[i+8].len>0)
			hinter->set_gateaccess((char*)vector[i+8].data);
		if(vector[i+9].len>0)
			hinter->set_timeout(*(int *)(vector[i+9].data));
		if(vector[i+10].len>0)
			hinter->set_optuserargs((char*)vector[i+10].data);
		list.push_back(hinter);	
		/*
		list.push_back(new topology::host(
				std::string((char*)vector[i+0].data,vector[i+0].len),
				std::string((char*)vector[i+1].data,vector[i+1].len),
				std::string((char*)vector[i+2].data,vector[i+2].len),
				std::string((char*)vector[i+3].data,vector[i+3].len),
				std::string((char*)vector[i+4].data,vector[i+4].len),
				std::string((char*)vector[i+5].data,vector[i+5].len),
				std::string((char*)vector[i+6].data,vector[i+6].len),
				*(int *)(vector[i+7].data),
				std::string((char*)vector[i+8].data,vector[i+8].len),
				*(int *)(vector[i+9].data),
				std::string((char*)vector[i+10].data,vector[i+10].len)
				));

		*/
		dbg.log("dojob","============= DOJOB 1 JOB ADDED TO LIST =============\n");
	}
	dbg.log("dojob","============= DOJOB ADD JOBS LIST TO SCHEDULER =============\n");
	_jschd->add_job(list);
	dbg.log("dojob","============= DOJOB DONE =============\n");
	//signal the new situation at sckd who's waiting for job
	//WARNING here we are executed by the thread router of the Taktuk
	//Network
}
/**********************************************************/
/**********************************************************/
