/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */



#ifndef __SPREAD_SCHEDULER_SERVICES_H
#define __SPREAD_SCHEDULER_SERVICES_H

#include <inuk/acom>

class scheduler;

/********************************************************************************/
/**	service job to give	a list of nodes to launch 
 *	@param job scheduler
 *
 */
class dojob : public acom::ServiceAM
{
	public:
		void initialize(scheduler* s);
	
		void call(
				acom::ComFailure::Code error_no,
				acom::Network::Receipt* receipt,
				acom::Network::Header* header,
				acom::IOVectEntry* vector,
				acom::IOVectSize count,
        void* ctxt
				) throw(acom::ComFailure);

	private:
		scheduler* _jschd;
};
/******************************************************************************/

//service to give info to one nodes
class setinfo : public acom::ServiceAM
{
	public:
		void initialize(scheduler* s);
		
		void call(
				acom::ComFailure::Code error_no,
				acom::Network::Receipt* receipt,
				acom::Network::Header* header,
				acom::IOVectEntry* vector,
				acom::IOVectSize count,
        void* ctxt
				) throw(acom::ComFailure);

	private:
		scheduler* _jschd;

};

/******************************************************************************/

//service to request info for this node
class getinfo : public acom::ServiceAM
{
	public:
		void initialize(scheduler* s);
		
		void call(
				acom::ComFailure::Code error_no,
				acom::Network::Receipt* receipt,
				acom::Network::Header* header,
				acom::IOVectEntry* vector,
				acom::IOVectSize count,
        void* ctxt
				) throw(acom::ComFailure);

	private:
		scheduler* _jschd;

};

/******************************************************************************/
//service to steal some nodes to launch
class steal : public acom::ServiceAM
{
	public:
		void initialize(scheduler* s);

		void call(
				acom::ComFailure::Code error_no,
				acom::Network::Receipt* receipt,
				acom::Network::Header* header,
				acom::IOVectEntry* vector,
				acom::IOVectSize count,
        void* ctxt
				) throw(acom::ComFailure);

	private:
		scheduler* _jschd;
};


#endif
