/*
 * The contents of this file are subject to the Dyade Public License,
 * as defined by the file DYADE_PUBLIC_LICENSE.TXT
 *
 * You may not use this file except in compliance with the License. You may
 * obtain a copy of the License on the Dyade web site (www.dyade.fr).
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific terms governing rights and limitations under the License.
 *
 * 
 * 
 *
 * The Initial Developer of the Original Code is Dyade. The Original Code and
 * portions created by Dyade are Copyright Bull and Copyright INRIA.
 * All Rights Reserved.
 */
/* Copyright (c) 1997 by Groupe Bull. Read the COPYRIGHT file. */
/* $Id: */
/* Author: Cyrille.Martin@imag.fr */

/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */

#include <inuk/taktuk/spawner.h>
#include <inuk/taktuk/connector.h>
#include <inuk/taktuk/topology.h>
#include <inuk/taktuk/debuglog.h>
#include <inuk/pth>
#include <iostream>
#include <vector>
#include <fcntl.h>
#include <map>
#include <inuk/taktuk/scheduler.h>
#include <stdlib.h>
#include <sys/time.h>
#include <time.h>

#include <fstream>
//getrusage include
#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>
//-----------------


#define MAXLOAD 8
//#define MAXLOAD 0.08
#define SIZE_LAST_TIMES 4 // specify the number of times saved in the vector to make the average



void spawner::checkload()
{

/* version 3
	struct timeval tps;
  double timecurr;
	double gap;
	double gapMoy;
	double gapmax;

//======get loadavg=======
	double load=0.0;
#ifndef PTH_USE_PTHREAD_IRIX
	getloadavg(&load,1);
#endif
//========================

//======get rusage========
	struct rusage usage;
	long nbctxtswitch=0;
	if(getrusage(RUSAGE_SELF, &usage)>=0)
	{
		nbctxtswitch=usage.ru_nvcsw+usage.ru_nivcsw;
	}

//========================
  
	gettimeofday(&tps,NULL);
  if(iter==0.0)
  {
    timeold=tps.tv_sec+0.000001*tps.tv_usec;
  }else
	{
		timecurr=tps.tv_sec+0.000001*tps.tv_usec;
		gap=(timecurr-timeold);
		if(iter==1.0)
			gapMoy=gap;
		else
			gapMoy=(gapsum/(iter-1.0));
		//dbg.log("tooloaded","timeold: %f timecurr: %f Gap: %f\n",timeold,timecurr,(timecurr-timeold));
		if(GapMax==0.0)
			gapmax=gapMoy*MAXLOAD;
		else
			gapmax=GapMax;
		dbg.log("tooloaded","Changement de contexte:%lu Loadavg:%f timeold: %f timecurr: %f Gap: %f GapMoy: %f GapMAX: %f\n",nbctxtswitch,load,timeold,timecurr,gap,gapMoy,gapmax);
		if (gap>gapmax)
		{
			loaded = true;
			GapMax=gapmax;
		}
		else
			loaded = false;
		timeold=timecurr;
		gapsum+=gap;
	}
	iter+=1.0;
	*/
}

bool spawner::tooloaded()
{
	double load;

	load=0.0;
	if(getloadavg(&load,1)<0)
		return false;
	else
		return (load > 0.6);
}

int spawner::connect(synch_vector<topology::host*>& reject, std::string& local_user,bool dyn)
{
	std::map<std::string,connector*,ltstr> todomap;
  std::map<std::string,connector*,ltstr>::iterator cur;
  PTH::CountDown cd;
	cd.init(0);
	std::vector<topology::host*> tospawn;
	connector* con;
	int laststeal;
	int id = 0;
	run_time rt; 
	run_time::job_time* last_time = NULL;
	run_time::job_time* new_time = NULL;
	int pipeline_size = 1; // size of the pipeline
	double ttotcount = 0.0; // temps total cumulee de tous les connecteurs
	double tpbcount = 0.0; // temps cumulee des partie non recouvrables des connecteurs
	int count = 0; // Nombre de connecteurs ayant deja fini
	bool beginning=true; // true if this is the beginning, false if this is the standard time 
	int nb_thread = 0; // number of thread connector running
	int cpt = 0; // usefull for the beginning
	
	
	if (scheduler::_maxthread!=250){
		pipeline_size=scheduler::_maxthread;
		beginning=false;
	}
	
	if(dyn)
		laststeal=1;
	else
		laststeal=ToDoList.size();

	startscheduler();

	while (get_job(tospawn,laststeal)>0)
	{
		if(dyn)
			id++;

		dbg.log("spawner","get a list of size %d to spawn\n",tospawn.size());
		/*for(int i=0;i<tospawn.size();i++)
			{
				dbg.log("spawner","host %d to spawn\n",i);
				dbg.log("spawner","host %d name %s\n",i,tospawn[i]->name.c_str());
				dbg.log("spawner","host %d connector %s\n",i,tospawn[i]->connector.c_str());
				dbg.log("spawner","host %d spreadargs %s\n",i,tospawn[i]->spreadargs.c_str());
				dbg.log("spawner","host %d userargs %s\n",i,tospawn[i]->userargs.c_str());
				dbg.log("spawner","host %d login %s\n",i,tospawn[i]->login.c_str());
				dbg.log("spawner","host %d passwd %s\n",i,tospawn[i]->passwd.c_str());
				dbg.log("spawner","host %d cmd %s\n",i,tospawn[i]->cmd.c_str());
				dbg.log("spawner","host %d fd %d\n",i,tospawn[i]->fd);
				dbg.log("spawner","host %d rank %d\n",i,tospawn[i]->rank);
				dbg.log("spawner","host %d size %d\n",i,tospawn[i]->size);
				dbg.log("spawner","host %d type %d\n",i,tospawn[i]->type);


			}
			*/
		//build the to do list for all connectors used
		for(int i=0;i<tospawn.size();i++)
		{
				
			if(todomap.find(tospawn[i]->connector)!=todomap.end())
				todomap[tospawn[i]->connector]->remote_hosts.push_back(tospawn[i]);
			else
			{
				if((con=connector_collector::get(tospawn[i]->connector))!=NULL)
				{
					con->remote_hosts.push_back(tospawn[i]);
					todomap[tospawn[i]->connector]=con;
				}
				else
				{
					//connector don't exist display an error message and 
					//set this node to the rejected list
					tospawn[i]->fd=-1;
					reject.push_back(tospawn[i]);
					std::cerr<<"Connector: "<<tospawn[i]->connector<<" unknow ABORT the node "
										<<tospawn[i]->name<<std::endl;
					dbg.log("WARNING","connector %s\
											unknow\n",tospawn[i]->connector.c_str());
					std::cerr<<"Available connectors are:"<<std::endl;
					for(std::map<std::string,WrapperFactoryBase*,ltstr>::iterator cur  = collector.begin();cur!=collector.end();cur++)
						std::cerr<<(*cur).first<<std::endl;
				}
			}
			// complete the command
			if(tospawn[i]->optuserargs.empty())
				tospawn[i]->cmd+=(" --  "+ tospawn[i]->userargs);
			else
				tospawn[i]->cmd+=(" --  "+ tospawn[i]->optuserargs);
		}      
		dbg.log("spawner","spawn begin\n");
      

		// call connector with his to do job
		for(cur  = todomap.begin();cur!=todomap.end();cur++)
		{
			if((*cur).second->remote_hosts.size()!=0)
	  		{
				dbg.log("spawner","use the connector [%s]\n",(*cur).first.c_str());
				//if error when launch thread decrement thread count
				//	checkload();
				dbg.log("spawner","pipeline size %i \n",pipeline_size);
				if(dyn)
				{
					dbg.log("spawner","On est bien en dynamique\n");
					if(!beginning)
					{
						dbg.log("spawner","On est plus au debut\n");
						if(nb_thread<pipeline_size)
						{
							++cd;
							nb_thread++;
							if((*cur).second->connect(&(reject),local_user,&cd,this,id,&rt)<0)
							{
								dbg.log("WARNING","connect session failed maybe can't create thread\n");
								--cd;
								nb_thread--;
							}
						}
						else
						{
							if (last_time!=NULL)
							{
								new_time=rt.get_time();
						 		nb_thread--;
								dbg.log("spawner","On a fini le get time\n");
								if(new_time->time()!=0)
								{
									dbg.log("spawner","On va calculer la moyenne\n");
									dbg.log("spawner","newtime  : %f,%i \n lasttime : %f,%i\n",new_time->time(),new_time->_jobid,last_time->time(),new_time->_jobid);
									tpbcount += (double)(new_time->_end.tv_sec - last_time->_end.tv_sec)+ (double)(new_time->_end.tv_usec - last_time->_end.tv_usec)*0.000001;
									ttotcount += new_time->time();
									count++;
									pipeline_size = (int)((ttotcount/(double)count) / (tpbcount/(double)count));
									dbg.log("spawner","Nouvelle moyenne : %d\n",pipeline_size);
									if(pipeline_size<1)
										pipeline_size=1;
									delete(last_time);
									last_time=new_time;
								}
							
							}
							else
							{
								last_time=rt.get_time();
							 	nb_thread--;
								if(last_time->time()==0)
								{
									delete(last_time);
									last_time=NULL;
								}
							}
							++cd;
							nb_thread++;
							if((*cur).second->connect(&(reject),local_user,&cd,this,id,&rt)<0)
							{
								dbg.log("WARNING","connect session failed maybe can't create thread\n");
								--cd;
								nb_thread--;
							}
						}
					}
					else
					{
						dbg.log("spawner","On est au debut et cpt vaut : %i\n",cpt);
						// ici mettre le demarrage temporisation eventuel etc...
						cpt++;
						if(cpt==3)
						{
							if (nb_thread>=pipeline_size)
							{
								dbg.log("spawner","On est avant le get_time\n");
								last_time=rt.get_time();
								nb_thread--;
								dbg.log("spawner","On est apres le get_time \n");
								beginning=false;
							}
							else
							{
								beginning=false;
							}
						}
						++cd;
					  	nb_thread++;
						if((*cur).second->connect(&(reject),local_user,&cd,this,id,&rt)<0)
						{
							dbg.log("WARNING","connect session failed maybe can't create thread\n");
							--cd;
							nb_thread--;
						}
					
					}
				}
				else
				{
					++cd;
					nb_thread++;
					if((*cur).second->connect(&(reject),local_user,&cd,this,id,&rt)<0)
					{
						dbg.log("WARNING","connect session failed maybe can't create thread\n");
						--cd;
			 			nb_thread--;
					}
				}
	  		
			}
		}
			if(dyn)
			{
				if(!beginning)
				{
					if( nb_thread!=0 &&  nb_thread>=pipeline_size)
					{
						dbg.log("spawner","On est avant le get_time\n");
						
						if (last_time!=NULL)
                                                        {
                                                                new_time=rt.get_time();
                                                                nb_thread--;
                                                                dbg.log("spawner","On a fini le get time\n");
                                                                if(new_time->time()!=0)
                                                                {
                                                                        dbg.log("spawner","On va calculer la moyenne\n");
                                                                        dbg.log("spawner","newtime  : %f,%i \n lasttime : %f,%i\n",new_time->time(),new_time->_jobid,last_time->time(),new_time->_jobid);
                                                                        tpbcount += (double)(new_time->_end.tv_sec - last_time->_end.tv_sec)+ (double)(new_time->_end.tv_usec - last_time->_end.tv_usec)*0.000001;
                                                                        ttotcount += new_time->time();
                                                                        count++;
                                                                        pipeline_size = (int)((ttotcount/(double)count) / (tpbcount/(double)count));
                                                                        dbg.log("spawner","Nouvelle moyenne : %d\n",pipeline_size);
                                                                        if(pipeline_size<1)
                                                                                pipeline_size=1;
                                                                        delete(last_time);
                                                                        last_time=new_time;
                                                                }

                                                        }
                                                        else
                                                        {
                                                                last_time=rt.get_time();
                                                                nb_thread--;
                                                                if(last_time->time()==0)
                                                                {
                                                                        delete(last_time);
                                                                        last_time=NULL;
                                                                }
                                                        }
					}
				}
			}
			// free the tospawn list
			tospawn.clear();
			todomap.clear();
	}
	//all thread connect must terminated
	dbg.log("spawner","final join ...............wait for %d threads\n",cd.getValue());
	cd.wait();
	dbg.log("spawner","final join ok\n");
	//set off scheduler thread and refresch info structure
	//terminate();
  if (reject.size() > 0)
  {
	return -1;
  }
  else
  {
	return 0;
  }
}


