/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */

#include "taktuknetwork.h"
#include "debuglog.h"
#include <iostream>
#include <stdlib.h>
#include <stdio.h>

#include <unistd.h>
#include <pwd.h>
#include <grp.h>  





#include <errno.h>
#include <string.h> 



int main(int argc, char *argv[])
{
  
  Taktuk::Network taktuk;
  int err=0;
  if((err=taktuk.initialize(&argc, &argv,false,false,false,false))<0)
    {
      switch (err)
	{
	case -1:
	  std::cerr<<argv[0]<<" syntax error"<<std::endl;
	  std::cerr<<argv[0];
	  taktuk.usage();
	  break;
	case -2:
	  std::cerr<<argv[0]<<" can't redirect standard IO"<<std::endl;
	  break;
	case -3:
	  std::cerr<<argv[0]<<" can't launch internal thread"<<std::endl;
	  break;
      }
      exit(1);
    }
  if(argc<1)
    {
      //taktuk.IO_on();
      std::cerr<<argv[0]<<" syntax error : no Taktuk or Inuktitut program specified"<<std::endl;
      taktuk.usage();
      taktuk.terminate();
      exit(1);
    }
 
  if(taktuk.commit()<0)
    {
      //taktuk.IO_on();
      std::cerr<<argv[0]<<" can't connect several host :"<<std::endl;
      taktuk.print_rejected();
      taktuk.terminate();
      return 1;
    }
  //taktuk.sync();

  setuid(getuid());
  setgid(getgid());
  

  argv = &argv[1];
  argc-=1;
  
  //  cout<<"noeud "<<taktuk.rank()<<" : arguments recu a la ligne de commande:"<<endl;
  //  for(int i =0; i<argc; i++)
  //    cout<<"rshp arg["<<i<<"] = "<<argv[i]<<endl;
  
  taktuk.exec_taktuk(argv);
  dbg.log("","ERROR exec refuse %s\n",strerror(errno));
  dbg.log("","ERROR exec refuse %s\n",argv[0]);
  std::cerr<<"node "<<taktuk.rank()<<" exec_taktuk() error"<<std::endl;

  //exit(-1);


  taktuk.terminate();
}
