/*
 * The contents of this file are subject to the Dyade Public License,
 * as defined by the file DYADE_PUBLIC_LICENSE.TXT
 *
 * You may not use this file except in compliance with the License. You may
 * obtain a copy of the License on the Dyade web site (www.dyade.fr).
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific terms governing rights and limitations under the License.
 *
 * 
 * 
 *
 * The Initial Developer of the Original Code is Dyade. The Original Code and
 * portions created by Dyade are Copyright Bull and Copyright INRIA.
 * All Rights Reserved.
 */
/* Copyright (c) 1997 by Groupe Bull. Read the COPYRIGHT file. */
/* $Id: */
/* Author: Cyrille.Martin@imag.fr */

/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */


#ifndef __TAKTUK_EXEC_H
#define __TAKTUK_EXEC_H

#include <stdio.h>
#include <sys/socket.h>
#include <errno.h>
#include <sys/types.h>
#include <unistd.h>
#include <vector>
#include <pwd.h>
#include <string>

int taktukexec(char* cmd,int* pid=NULL)
{
  int fd[2];
	int nodelay=1;
  int child_pid;


  if(socketpair(AF_LOCAL, SOCK_STREAM,0,fd)<0)
    {
      return -1;
    }
	
	setsockopt(fd[0],IPPROTO_TCP,TCP_NODELAY,&nodelay,sizeof(nodelay));
	setsockopt(fd[1],IPPROTO_TCP,TCP_NODELAY,&nodelay,sizeof(nodelay));
  
	if ((child_pid = fork()) == -1)
	{
	  perror("taktuk exec: fork error");
	  return -1;
	}

  if (child_pid != 0)
    {//father
			if(pid!=NULL)
				*pid=child_pid;
      close(fd[1]);
      return fd[0];
    }
  else
    {//child
      //struct passwd *pwd;
      for(int i=0;i<3;i++)
				close(i);

      close(fd[0]);
      if(dup2(fd[1],0)<0)
	;
      if(dup2(fd[1],1)<0)
	;
      if(dup2(fd[1],2)<0)
	;

      //now 0,1,2 were redirect on fd[1], e can close fd[1]
      close(fd[1]);


//build arguments before the exec
      char **args;
      std::vector<std::string> argstab;
      char * word=NULL;
      
      static char* exe= strcpy((char*)malloc((strlen(cmd)+1)*sizeof(char)),cmd);

      word=strtok(exe," ");
      while(word!=NULL)
	{
	  argstab.push_back(word);
	  word=strtok(NULL," ");
	}
      
      args=(char**)malloc(sizeof(char*)*(argstab.size()+1));
      for(int i=0; i<argstab.size();i++)
				args[i]=(char*) argstab[i].c_str();
      args[argstab.size()]=NULL; //args is Null terminated

//      for(int i=0;args[i]!=NULL;i++)
      
      execvp(args[0],args);
			for(int i=0;i<3;i++)
				close(i);

    }
	return -1;
}
#endif
