#include "taktukrouter.h"
#include "taktuknetwork.h"
#include "CoreTCP.h"
#include "debuglog.h"
#include <inuk/acom>
#ifdef INUKTITUT_USE_DARWIN
#include <stdlib.h>
#else
#include <alloca.h>
#endif

void taktuk_router::bcast(InfoTCPnet::link* link,
        acom::Network::CallContext* cxt,
        acom::IOVectEntry* iov,
        int32_t* iov_dsz,
        void* im_data)
{
  Taktuk::Network::CallContext* cc= (Taktuk::Network::CallContext*)cxt;  
  //dbg.log("process","incoming  message is for me and for all other redirect it before call the service\n");
  //send the message to on all link less one
  for(int i=0;i<info.all_links.size();i++)
  {
    if(info.all_links[i]->_peer!=link->_peer && info.all_links[i]->open())
    {
      //dbg.log("process","redirect message to %d\n",info.all_links[i]._peer);
      info.all_links[i]->lock();
      //send the header
      info.all_links[i]->_sock->writen((void*)&cc->receipt->_header, sizeof(acom::Network::Header));
      //send header extend
      if (cc->receipt->_header.size_eh>0)
      {
        link->_sock->writen(cc->ext_header, cc->receipt->_header.size_eh);
      }
      //send the description tab
      if(cc->receipt->_header.iovsz_d>0)
        info.all_links[i]->_sock->writen(iov_dsz, sizeof(int32_t)*cc->receipt->_header.iovsz_d);
      //send immediate data
      if(cc->receipt->_header.size_h>0)
        info.all_links[i]->_sock->writen(im_data, sizeof(char)*cc->receipt->_header.size_h);
      //send defered data
      for(int ii=0;ii<cc->receipt->_header.iovsz_d;ii++)
      {
        if(iov[ii].len>0)
          info.all_links[i]->_sock->writen(iov[ii].data,iov[ii].len);
      }
      info.all_links[i]->unlock();
      //dbg.log("process","redirect message to %d terminated\n",info.all_links[i]._peer);
      
    }
  }
}

// CAUTION all read are done by this function call in sequential mode so
// don't lock the fd we can't have multiple read at the same time

int taktuk_router::process(InfoTCPnet::link* link,int linkID)
{
	
	dbg.log("process","process BEGIN\n");
	Taktuk::Network::CallContext* cc = 0;
	cc = _net->acquire_callcontext();

	acom::Service* s=NULL;
	int32_t* iov_dsz; 
	void* im_data;
	int data_to_read=0;
 
	if(link==NULL ||  link->_sock == NULL || !link->_sock->valid())
		return -1;

	if(link->_sock->readn((void*)&cc->receipt->_header,sizeof(acom::Network::Header))<=0)
	{
		dbg.log("process","ERROR process link broken during read of header\n");
		return -1;
	}
	dbg.log("process","process a new msg HEADER:\nim data sz: %d\ndef data sz: \
		%d\ndest : %d\nproto : %d\nservice id : %d\niovd sz : %d\nemet : %d\nno :%d\
		\n",cc->receipt->_header.size_h,cc->receipt->_header.size_d,cc->receipt->_header.dst,cc->receipt->_header.protocol,cc->receipt->_header.id,cc->receipt->_header.iovsz_d,cc->receipt->_header.src,cc->receipt->_header.no);
	//IT'S FOR ME?????

   if(cc->receipt->_header.dst==InfoTCPnet::ALL || cc->receipt->_header.dst==InfoTCPnet::YOU || cc->receipt->_header.dst == info.rank)
   {
     // YES IT'S FOR ME :-)
  
     dbg.log("process","incoming message is for me process it\n"); 

     /* resize call context is necessary to store : iovector + descr of iovect + immediate data
     */
     size_t sz_incc =   cc->receipt->_header.iovsz_d * (sizeof(acom::IOVectEntry) + sizeof(size_t)) 
                     + cc->receipt->_header.size_eh; 
     if ( sz_incc >= cc->free_size() )
     {
       size_t newsz = 2*sz_incc;
       cc = _net->resize_callcontext( cc, newsz );
     }

     /* cc->header should points to the header data structure: here in receipt 
     */
     cc->header = &cc->receipt->_header;
     cc->iov_sz = cc->receipt->_header.iovsz_d;

     if (cc->header->size_eh>0)
     {
       /* Read extended header : 
       */
       cc->ext_header = cc->allocate(cc->header->size_eh);
       if(link->_sock->readn(cc->ext_header, cc->header->size_eh)<=0)
       {
         dbg.log("process","ERROR process link broken during read of header\n");
         return -1;
      }
      dbg.log("process","process a new msg HEADER:\nim data sz: %d\ndef data sz: \
        %d\ndest : %d\nproto : %d\nservice id : %d\niovd sz : %d\nemet : %d\nno :%d\
        \n",cc->receipt->_header.size_h,cc->receipt->_header.size_d,cc->receipt->_header.dst,cc->receipt->_header.protocol,cc->receipt->_header.id,cc->receipt->_header.iovsz_d,cc->receipt->_header.src,cc->receipt->_header.no);
    } 
    else
      cc->ext_header = 0;


    /* build the iovector of deferred data on the stack
    */
    if(cc->receipt->_header.iovsz_d>0)
    {
       cc->iov=(acom::IOVectEntry*) cc->allocate(sizeof(acom::IOVectEntry)*(cc->receipt->_header.iovsz_d));
       if(cc->iov==NULL)
       {
         dbg.log("ERROR","process CAN'T ALLOCATE DATA FOR IOV DESC\n");
         return -1;
       }
       iov_dsz=(int32_t*)cc->allocate(sizeof(int32_t)*cc->receipt->_header.iovsz_d);
       if(iov_dsz==NULL)
       {
         dbg.log("ERROR","process CAN'T ALLOCATE DATA FOR IOV DESC\n");
         return -1;
       }

       if(link->_sock->readn((void*)iov_dsz,sizeof(int32_t)*cc->receipt->_header.iovsz_d)<0)
       {
         //link->unlock();
         return -1;
       }

       for(int i=0;i<cc->receipt->_header.iovsz_d;i++)
       {
         //dbg.log("process","descrition def data len no %d = %d\n",i,iov_dsz[i]);
         cc->iov[i].len=iov_dsz[i];
       }
     }
     else
     {
       cc->iov=NULL;
       iov_dsz=NULL;
     }
     //alloc & read imediate data
     if(cc->receipt->_header.size_h>0)
     {
       im_data= cc->allocate(sizeof(char)*cc->receipt->_header.size_h);
       if(im_data==NULL)
       {
         dbg.log("ERROR","process CAN'T ALLOCATE DATA FOR IOV DESC\n");
         return -1;
       }
       if(link->_sock->readn((void*)im_data,sizeof(char)*cc->receipt->_header.size_h)<0)
       {
         return -1;
       }
     }
     else
       im_data=NULL;

     //initialize the receipt request
     cc->_im_data_seq.init( _nb_entries, &_iovA);
     if(cc->receipt->_header.size_h>0)
           cc->_im_data_seq.put(im_data,cc->receipt->_header.size_h);

     Taktuk::Network::TaktukReceipt* thereceipt = (Taktuk::Network::TaktukReceipt*)cc->receipt;
     thereceipt->init((acom::IOVectSeq*)&cc->_im_data_seq,cc->iov,cc->receipt->_header.iovsz_d,_net,linkID);
     cc->cc =0;
     cc->error_no = acom::ComFailure::OK;

     dbg.log("process","receipt initilized works on defered data\n"); 

     //proceed defered data

    //allocate data for AM and AWS
    if(cc->receipt->_header.protocol==Taktuk::Network::P_AM || cc->receipt->_header.protocol==Taktuk::Network::P_AWS)
    {
      for(int i=0; i<cc->receipt->_header.iovsz_d; i++)
      {
        if(cc->iov[i].len>0)
          cc->iov[i].data=_net->allocate_data(cc->iov[i].len);
        else
          cc->iov[i].data=0;
      }
    }
    //get iovector from user for WS
    try
    {
       s= acom::Service::Manager.resolv(cc->receipt->_header.id);
       if(cc->receipt->_header.protocol==Taktuk::Network::P_WS)
       {
           s->server_get_iovect( cc );
       }
     }
     catch(...)
     {
        dbg.log("WARNING","service number %d CAN'T CALL GETIOVECT\n",cc->receipt->_header.id);
        if(clean_link(link,data_to_read)<0)
        {
          return -1;
        }else
          return 0;
     }


    //read data from network
    data_to_read=cc->receipt->_header.size_d;
    for(int i=0; i<cc->receipt->_header.iovsz_d; i++)
    {
      if(cc->iov[i].len>0)
      {
        dbg.log("process","read %d data of iov len %d\n",i,cc->iov[i].len);
        if(link->_sock->readn( cc->iov[i].data,cc->iov[i].len)<0)
        {
					dbg.log("process","ERROR when reading deferred data\n");
          return -1;
        }
        data_to_read-=cc->iov[i].len;
      }else
			{
        dbg.log("process","read %d data of iov len %d\n",i,cc->iov[i].len);
        cc->iov[i].data=0;
			}
    }
    if(data_to_read>0)
    {
       dbg.log("process","BAD SIZE MESSAGE DETECTED ....... clean the network\n");
       if(clean_link(link,data_to_read)<0)
       {
         return -1;
       }
    }
    if(cc->receipt->_header.dst==InfoTCPnet::ALL)
    {
      // IT'S A BCAST MESSAGE FOR ALL
      bcast(link,cc, cc->iov,iov_dsz,im_data);
    }

    try
    {
        s->server_call( cc );
    }
    catch(const PTH::RuntimeError &e)
    {
       dbg.log("WARNING","service number %d unkown by Service Manager\n[%s]\n",cc->receipt->_header.id,e.what());
    }

    /// free blocks if AM
    if(cc->receipt->_header.protocol==Taktuk::Network::P_AM)
    {
      for(int i=0; i<cc->receipt->_header.iovsz_d; i++)
      {
        _net->deallocate_data( cc->iov[i].data);
      }
    }

  }
  else
  {
      // IT'S NOT FOR ME :-(
      //redirect the message 
      dbg.log("process","incoming message is not for me redirect it to %d\n",cc->receipt->_header.dst); 
      int dest;
      dest = info.route_table[cc->receipt->_header.dst];
      //	  	dbg.log("process","redirect message to %d\n",info.all_links[dest]._peer); 
      if(info.all_links[dest]->_peer!=link->_peer && info.all_links[dest]->_sock!=NULL && info.all_links[dest]->_sock->valid())
      {
        int sizetodo=cc->receipt->_header.size_h + cc->receipt->_header.size_eh + cc->receipt->_header.size_d + 
                                              (sizeof(int32_t)*cc->receipt->_header.iovsz_d);
        //			dbg.log("process","redirect message begin size of msg %d\n",sizetodo); 
        int nbread=0;   
        info.all_links[dest]->lock();
        info.all_links[dest]->_sock->writen(&cc->receipt->_header,sizeof(acom::Network::Header));
        //			dbg.log("process","redirect message  header sent \n"); 
        //			dbg.log("process","REDIRECTED HEADER:\nim data sz: %d\ndef data sz: \
        //						 %d\ndest : %d\nproto : %d\nservice id : %d\niovd sz : %d\nemet : %d\nno :%d\
        //						\n",cc->receipt._header.size_h,cc->receipt._header.size_d,cc->receipt._header.dst,cc->receipt._header.protocol,cc->receipt._header.id,cc->receipt._header.iovsz_d,cc->receipt._header.src,cc->receipt._header.no);

        while(sizetodo>0)
        {
            nbread=link->_sock->readn(receive_buffer,sizetodo>MAXBUF ? MAXBUF : sizetodo);
            if(nbread<0)
            {
              info.all_links[dest]->unlock();
							dbg.log("process","ERROR when reading buffer to redirect\n");
              return -1;
            }
            if(info.all_links[dest]->_sock->writen(receive_buffer,nbread)<0)
              dbg.log("WARNING","WARNING in redirection msg write problem data will be lost !!!\n");
            sizetodo-=nbread;
         }
         info.all_links[dest]->unlock();
         //			dbg.log("process","redirect message completed\n"); 
  
      }
      else // free the net ROUTING ERROR
      {
        dbg.log("WARNING","ROUTING ERROR MESSAGE DELETED\n");
        int sizetodo=cc->receipt->_header.size_h + cc->receipt->_header.size_eh + cc->receipt->_header.size_d + 
                (sizeof(int32_t)*cc->receipt->_header.iovsz_d);
        int nbread=0;
        for(;sizetodo>0;)
        {
          nbread=link->_sock->readn(receive_buffer,sizetodo>MAXBUF ? MAXBUF : sizetodo);
          if(nbread<=0)
          {
            //link->unlock();
						dbg.log("process","ERROR when reading buffer to redirect\n");
            return -1;
          }
          sizetodo-=nbread;
        }
      }
   }
   // end of reception
   cc->release();
   dbg.log("process","COMPLETED CORRECTLY\n");
   return 1;
}
